--
-- keyhandler
--



-----------------------------------------------------------------------------------------------
--play/stop pattern
local function rnd_kh_play_stop_pattern(mode)
  if not (song.transport.playing) then
    if (mode==1) then
      song.transport:start(renoise.Transport.PLAYMODE_RESTART_PATTERN)
    else
      song.transport:start_at(song.selected_line_index)
    end
  else
    song.transport:stop()
  end
end



-----------------------------------------------------------------------------------------------
--undo/redo
function rnd_kh_undo()
  if (song:can_undo()) then
    song:undo()
  end
end
---
function rnd_kh_redo()
  if (song:can_redo()) then
    song:redo()
  end
end



-----------------------------------------------------------------------------------------------
--left/right track | left/right note column
local function rnd_kh_nav_tracks(value)
  local raw=renoise.ApplicationWindow
  if (rna.window.active_middle_frame~=raw.MIDDLE_FRAME_PATTERN_EDITOR) then
    rna.window.active_middle_frame=raw.MIDDLE_FRAME_PATTERN_EDITOR
  end
  local sti=song.selected_track_index
  if (value>0) then
    if (#song.tracks>=sti+value) then
      song.selected_track_index=sti+value
    else
      song.selected_track_index=1
    end
  else
    if (1<=sti+value) then
      song.selected_track_index=sti+value
    else
      song.selected_track_index=#song.tracks
    end
  end
end



-----------------------------------------------------------------------------------------------
--up/down sequence
local function rnd_kh_nav_sequence(value)
  local raw=renoise.ApplicationWindow
  if (rna.window.active_middle_frame~=raw.MIDDLE_FRAME_PATTERN_EDITOR) then
    rna.window.active_middle_frame=raw.MIDDLE_FRAME_PATTERN_EDITOR
  end
  local ssi=song.selected_sequence_index
  local sps=#song.sequencer.pattern_sequence
  if (value>0) then
    if (sps>=ssi+value) then
      song.selected_sequence_index=ssi+value
    else
      song.selected_sequence_index=1
    end
  else
    if (1<=ssi+value) then
      song.selected_sequence_index=ssi+value
    else
      --song.selected_sequence_index=sps
    end
  end
end



-----------------------------------------------------------------------------------------------
--up/down instrument
local function rnd_kh_nav_instrument(value)
  local sii=song.selected_instrument_index
  local sin=#song.instruments
  if (value>0) then
    if (sin>=sii+value) then
      song.selected_instrument_index=sii+value
    else
      song.selected_instrument_index=1
    end
  else
    if (1<=sii+value) then
      song.selected_instrument_index=sii+value
    else
      --song.selected_instrument_index=sin
    end
  end
end



-----------------------------------------------------------------------------------------------
--keyhandler
function rnd_keyhandler(dialog, key)
  print("name:", key.name, "|   modifiers:", key.modifiers, "|   character:", key.character, "|   note:", key.note, "|   repeated:", key.repeated)
  
  --close window
  if (key.name=="r") and (key.modifiers=="shift") and not (key.repeated) then
    if (RND_MAIN_DIALOG) and (RND_MAIN_DIALOG.visible==true) then RND_MAIN_DIALOG:close() end
  end
  

  --undo/redo
  if (key.name=="z") and (key.modifiers=="control") then if not (key.repeated) then rnd_kh_undo() else rnd_kh_undo() end end
  if (key.name=="y") and (key.modifiers=="control") then if not (key.repeated) then rnd_kh_redo() else rnd_kh_redo() end end

  if not (key.modifiers=="shift+alt") and not (key.modifiers=="shift+control") and not (key.modifiers=="alt+control") and
  not (key.modifiers=="alt") and not (key.modifiers=="control") and not (key.modifiers=="shift") then
  
    --left/right track
    if (key.name=="left") then if not (key.repeated) then rnd_kh_nav_tracks(-1) else rnd_kh_nav_tracks(-1) end end
    if (key.name=="right") then if not (key.repeated) then rnd_kh_nav_tracks(1) else rnd_kh_nav_tracks(1) end end  
  
    --up/down sequence (ctrl)
    if (key.name=="up") then if not (key.repeated) then rnd_kh_nav_sequence(-1) else rnd_kh_nav_sequence(-1) end end
    if (key.name=="down") then if not (key.repeated) then rnd_kh_nav_sequence(1) else rnd_kh_nav_sequence(1) end end
  
    --up/down instrument
    if (key.name=="numpad -") then if not (key.repeated) then rnd_kh_nav_instrument(-1) else rnd_kh_nav_instrument(-1) end end
    if (key.name=="numpad +") then if not (key.repeated) then rnd_kh_nav_instrument(1) else rnd_kh_nav_instrument(1) end end
  end
  
  --controls to render
  if not (key.modifiers=="shift+alt") and not (key.modifiers=="shift+control") and not (key.modifiers=="alt+control") and
  not (key.modifiers=="alt") and not (key.modifiers=="control") and not (key.modifiers=="shift") and not (key.repeated) then
    if (key.name=="apps") then rnd_bt_edit_wave() end
    if (key.name=="space") then rnd_kh_play_stop_pattern(1) end
    if (key.name=="rcontrol") then rnd_render_song() end
  end
end
