-----------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------
--
-- Tool name: SamRender
-- Version: 1.7 build 012
-- Compatibility: Renoise v3.2.0
-- Development date: June 2018 - May 2020
-- Published: May 2020
-- Locate: Spain
-- Programmer: ulneiz
--
-----------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------


--**************************************
--collectgarbage (top)
  --collectgarbage( "stop" )
--**************************************

local RND_VB_HEIGHT=19
local RND_VB_HEIGHT_2=23



local function rnd_test()
  --test
end



-------------------------------------------------------------------------------------------------
--main local/global variables/tables
RND_MAIN_DIALOG=nil
RND_MAIN_CONTENT=nil
RND_INVOKE_STATUS=true
local rnd_main_title="SamRender"
local rnd_version="1.7 build 012"
local rns_version=renoise.RENOISE_VERSION
---
local vb=renoise.ViewBuilder()
vws=vb.views
rna=renoise.app()
rnt=renoise.tool()

--global song
song=nil
  function rnd_sng() song=renoise.song() end --define global "song"
  rnt.app_new_document_observable:add_notifier( rnd_sng ) --catching start renoise or new song
  pcall( rnd_sng ) --catching installation



-------------------------------------------------------------------------------------------------
--main locals

local RND_ABOUT_TFD=
  "TOOL NAME: "..rnd_main_title.."\n"..
  "VERSION: "..rnd_version.." \n"..
  "COMPATIBILITY: Renoise 3.2.1 (tested in Windows 10)\n"..
  "DEVELOPMENT DATE: June 2018 - May 2020\n"..
  "PUBLISHED: May 2020\n"..
  "OPEN SOURCE: Yes\n"..
  "LICENCE: GNU GPL. Prohibited use commercial ambit\n"..
  "CODE: LUA 5.1 + API 6 (Renoise 3.2.1)\n"..
  "PROGRAMMER / CODE OWNER: ulneiz (Spain).\n"..
  "CONTACT: \"https://forum.renoise.com/\" & search: \"ulneiz\"."
local RND_COM_TITLE={"About "..rnd_main_title,"Basic Key Commands"}
local RND_COM_TXT={
  "[R.CTRL] Start/stop render", "[APPS] P.E./Waveform",
  "[CTRL + Z] Undo", "[CTRL + Y] Redo",
  "[LEFT]  [RIGHT] Track", "[UP]  [DOWN] Sequence",
  "[+]  [-] Instrument", "[SPACE] Play/stop song",
  "*[SHIFT + R] Open window", "[SHIFT + R] Close window",
  "*Assignable: Preferences/Keys:Global/Tools/SamRender",
  "",
  "",
  ""
}

local RND_CLR_RED={120,0,0}
local RND_CLR_DEF={0,0,0}
local RND_DIRECT=false



-------------------------------------------------------------------------------------------------
--main functions


--for matrix selection, check the track-sequence selected
local RND_TRK={1,1}
local RND_SEQ={1,1}
local RNK_TRK_MUTE_STATE={}

local function rnd_check_sel_trk_seq()
  local ssq=song.sequencer
  local function inv()
    for trk_2=#song.tracks,1,-1 do
      for seq_2=#ssq.pattern_sequence,1,-1 do
        if (ssq:track_sequence_slot_is_selected(trk_2,seq_2)==true) then
          RND_TRK[2]=trk_2
          RND_SEQ[2]=seq_2
        return --rprint(RND_TRK),rprint(RND_SEQ)
        end
      end
    end
  end
  for trk_1=1,#song.tracks do
    for seq_1=1,#ssq.pattern_sequence do
      if (ssq:track_sequence_slot_is_selected(trk_1,seq_1)==true) then
          RND_TRK[1]=trk_1
          RND_SEQ[1]=seq_1
      return inv()
      end
    end
  end
end



local function rnd_check_sel_trk_lns()
  if (song.selection_in_pattern) then
    RND_TRK[1]=song.selection_in_pattern.start_track
    RND_TRK[2]=song.selection_in_pattern.end_track
  else
    RND_TRK[1]=song.selected_track_index
    RND_TRK[2]=song.selected_track_index
  end
  --rprint(RND_TRK)
end




  --render the song
    -- options={
    --   start_pos,     -- renoise.SongPos object. by default the song start.
    --   end_pos,       -- renoise.SongPos object. by default the song end.
    --   sample_rate,   -- one of 22050, 44100, 48000, 88200, 96000, 192000. \
    --                  -- by default the players current rate.
    --   bit_depth ,    -- number, one of 16, 24 or 32. by default 32.
    --   interpolation, -- string, one of 'default', 'precise'. by default default'.
    --   priority,      -- string, one "low", "realtime", "high". \
    --                  -- by default "high".
    -- }
local RND_DONE_CANCEL=true
local function rnd_procress_done()
  vws.RND_TXT_PATH_FOLDER.text=""
  if rnt:has_timer(rnd_procress_done) then
    rnt:remove_timer(rnd_procress_done)
  end
  RND_DONE_CANCEL=true
end
---
local function rnd_process_bar()
  if (song.rendering==false) then
    if rnt:has_timer(rnd_process_bar) then
      rnt:remove_timer(rnd_process_bar)
      if (RND_DONE_CANCEL) then
        vws.RND_TXT_PATH_FOLDER.text="Done!"
      else
        vws.RND_TXT_PATH_FOLDER.text="Stopped here!"
      end
      if not rnt:has_timer(rnd_procress_done) then
        rnt:add_timer(rnd_procress_done,3000)
      end
      vws.RND_BMP_PROCESS.width=1
      vws.RND_BMP_PROCESS.visible=false
    end  
  else
    if not (vws.RND_BMP_PROCESS.visible) then
      vws.RND_BMP_PROCESS.visible=true
    end
    local render_prog=song.rendering_progress
    if (render_prog>=0.01) then
      vws.RND_BMP_PROCESS.width=230*render_prog
      if (render_prog>0.99) then
        vws.RND_TXT_PATH_FOLDER.text="Progress: 100 %"
      else
        vws.RND_TXT_PATH_FOLDER.text=("Progress: %.2f %%"):format(render_prog*100)
      end
    end
  end
end



local function rnd_auto_sel_matrix(tr)
  local ssq=song.sequencer
  --print(#ssq.pattern_sequence)
  --restore selected slot
  for trk=1,#song.tracks do
    for seq=1,#ssq.pattern_sequence do
      if (ssq:set_track_sequence_slot_is_selected(trk,seq,false)) then
        ssq:set_track_sequence_slot_is_selected(trk,seq,true)
      end
    end
  end
  if (song:track(tr).type==renoise.Track.TRACK_TYPE_SEQUENCER) then
    --print("tr")
    for seq=RND_SEQ[1],RND_SEQ[2] do
      ssq:set_track_sequence_slot_is_selected(tr,seq,true)
    end
  elseif (song:track(tr).type==renoise.Track.TRACK_TYPE_GROUP) then
    --print("gr")
    for trk= tr-#song:track(tr).members,tr do
      for seq=RND_SEQ[1],RND_SEQ[2] do
        ssq:set_track_sequence_slot_is_selected(trk,seq,true)
      end
    end
  end
end



function rnd_render_song()
  local clk=os.clock()
  local function rnd_txt_piece_song()
    if (vws.RND_SW_PIECE_SONG.value==1) then
      vws.RND_BT_RENDER.text="Render Song"
    elseif (vws.RND_SW_PIECE_SONG.value==3) then
      vws.RND_BT_RENDER.text="Render Matrix"
    elseif (vws.RND_SW_PIECE_SONG.value==2) then
      vws.RND_BT_RENDER.text="Render Seq."
    else
      vws.RND_BT_RENDER.text="Render Pattern"
    end
    vws.RND_BT_RENDER.color=RND_CLR_DEF
  end
  ---
  if (song.rendering==false) then
    rna.window.active_middle_frame=renoise.ApplicationWindow.MIDDLE_FRAME_PATTERN_EDITOR
    vws.RND_BT_RENDER.text="Stop"
    vws.RND_BT_RENDER.color=RND_CLR_RED
    if not rnt:has_timer(rnd_process_bar) then
      rnt:add_timer(rnd_process_bar,5)
    end
    local settings={}
    --renoise.SongPos(sequence,line)
    local start_pos=renoise.SongPos()
    local end_pos=renoise.SongPos()
    local seq=song.sequencer
    local sps=#seq.pattern_sequence
    local stc=song.sequencer_track_count
    if (vws.RND_SW_PIECE_SONG.value==1) then --entire song
      start_pos.sequence=1
      start_pos.line=1
      end_pos.sequence=sps
      end_pos.line=song:pattern(seq:pattern(sps)).number_of_lines
    elseif (vws.RND_SW_PIECE_SONG.value==2) then --sequence range
      if (vws.RND_RW_SEQ_RANGE_1.value>=sps) or
         (vws.RND_RW_SEQ_RANGE_2.value>=sps) then
        rnd_txt_piece_song()
        --[[
        if rnt:has_timer( rnd_process_bar) then
          rnt:remove_timer(rnd_process_bar)
        end
        ]]
        return rna:show_error(("%s:\nPlease, to render enter a valid sequence range < %s.\nOnly exist 0 to %s."):format(rnd_main_title,sps,sps-1))
      else
        if (vws.RND_CHK_SEQ_RNG_AUTO_ADJUST.value) then
          vws.RND_RW_SEQ_RANGE_1.value=seq.selection_range[1]-1
          vws.RND_RW_SEQ_RANGE_2.value=seq.selection_range[2]-1
        end
        start_pos.sequence=vws.RND_RW_SEQ_RANGE_1.value+1
        end_pos.sequence=vws.RND_RW_SEQ_RANGE_2.value+1
        start_pos.line=1
        end_pos.line=song:pattern( seq:pattern(vws.RND_RW_SEQ_RANGE_2.value+1)).number_of_lines
      end
    elseif (vws.RND_SW_PIECE_SONG.value==3) then --selection in matrix
      rnd_check_sel_trk_seq()
      start_pos.sequence=RND_SEQ[1]
      end_pos.sequence=RND_SEQ[2]
      start_pos.line=1
      end_pos.line=song:pattern(seq:pattern(RND_SEQ[2])).number_of_lines
      RNK_TRK_MUTE_STATE=table.create()
      for trk=1,stc do --#song.tracks do
        RNK_TRK_MUTE_STATE:insert(song:track(trk).mute_state)
        if (trk<RND_TRK[1]) or (trk>RND_TRK[2]) then
          if (song:track(trk).type==renoise.Track.TRACK_TYPE_SEQUENCER) then
            song:track(trk):mute()
          end
        end
      end
      --rprint(RNK_TRK_MUTE_STATE)
    else --selection in pattern
      start_pos.sequence=song.selected_sequence_index
      end_pos.sequence=song.selected_sequence_index
      local nol=song.selected_pattern.number_of_lines
      local function error()
        return rna:show_error(("%s:\nPlease, to render enter a valid lines range < %s.\nOnly exist 00 to %.2d lines.\nAlso, it is not "..
                                 "possible to render a single line!"):format(rnd_main_title,nol,nol-1))
      end
      if (vws.RND_CHK_LNS_RNG_AUTO_ADJUST.value) then
        vws.RND_RW_LNS_RANGE_2.max=nol
        vws.RND_RW_LNS_RANGE_1.max=nol-1
        if (song.selection_in_pattern) then
          if (song.selection_in_pattern.start_line~=song.selection_in_pattern.end_line) then
            vws.RND_RW_LNS_RANGE_1.value=song.selection_in_pattern.start_line-1
            vws.RND_RW_LNS_RANGE_2.value=song.selection_in_pattern.end_line-1
          else
            if (song.selection_in_pattern.start_line<nol) then
              vws.RND_RW_LNS_RANGE_1.value=song.selection_in_pattern.start_line-1
              vws.RND_RW_LNS_RANGE_2.value=song.selection_in_pattern.start_line
            else
              rnd_txt_piece_song()
              return error()
            end
          end
        else
          if (song.selected_line_index<nol) then
            vws.RND_RW_LNS_RANGE_1.value=song.selected_line_index-1
            vws.RND_RW_LNS_RANGE_2.value=song.selected_line_index
          else
            rnd_txt_piece_song()
            return error()
          end
        end
      end
      ---
      rnd_check_sel_trk_lns()
      ---
      RNK_TRK_MUTE_STATE=table.create()
      for trk=1,stc do --#song.tracks do
        RNK_TRK_MUTE_STATE:insert(song:track(trk).mute_state)
        if (trk<RND_TRK[1]) or (trk>RND_TRK[2]) then
          if (song:track(trk).type==renoise.Track.TRACK_TYPE_SEQUENCER) then
            song:track(trk):mute()
          end
        end
      end
      start_pos.line=vws.RND_RW_LNS_RANGE_1.value+1
      end_pos.line=vws.RND_RW_LNS_RANGE_2.value+1
    end
    settings.start_pos=start_pos
    settings.end_pos=end_pos
  
    --interpolation
    local interpolation="precise"
    if (vws.RND_OPT_INTERPOLATION.value==1) then
      interpolation="default"
    else
      interpolation="precise"
    end
    settings.interpolation=interpolation
    
    --priority
    local priority="hight"
    if (vws.RND_OPT_PRIORITY.value==1) then
      priority="realtime"
    elseif (vws.RND_OPT_PRIORITY.value==2) then
      priority="low"
    elseif (vws.RND_OPT_PRIORITY.value==3) then
      priority="high"
    end
    settings.priority=priority
    
    --sample_rate
    local sample_rate=48000
    if (vws.RND_OPT_SAMPLE_RATE.value==1) then
      sample_rate=22050
    elseif (vws.RND_OPT_SAMPLE_RATE.value==2) then
      sample_rate=44100
    elseif (vws.RND_OPT_SAMPLE_RATE.value==3) then
      sample_rate=48000
    elseif (vws.RND_OPT_SAMPLE_RATE.value==4) then
      sample_rate=88200
    elseif (vws.RND_OPT_SAMPLE_RATE.value==5) then
      sample_rate=96000
    else
      sample_rate=192000
    end
    settings.sample_rate=sample_rate
  
    --bit_depth
    local bit_depth=32
    if (vws.RND_OPT_BIT_DEPTH.value==1) then
      bit_depth=16
    elseif (vws.RND_OPT_BIT_DEPTH.value==2) then
      bit_depth=24
    else
      bit_depth=32
    end
    settings.bit_depth=bit_depth
  
    --filename
    local filename=os.tmpname("wav") --temporal folder: C:\Users\USER_NAME\AppData\Local\Temp\Renoise-0-????\
  
    --rendering_done_callback
    local function rendering_done_callback()
      --print(filename)
      local sel_ins=song.selected_instrument_index
      local sel_sam=song.selected_sample_index
      --load the wav, rename instrument and clear temporal file
      if (vws.RND_SW_DESTINATION.value==1) then
        if (song.selected_sample_index==0) then
          song:instrument(sel_ins):insert_sample_at(1)
          sel_sam=1
        end
      elseif (vws.RND_SW_DESTINATION.value==2) then  
        local new_sam=#song:instrument(sel_ins).samples+1
        --print(new_sam)
        song:instrument(sel_ins):insert_sample_at(new_sam)
        song.selected_sample_index=new_sam
        sel_sam=song.selected_sample_index
      elseif (vws.RND_SW_DESTINATION.value==3) then
        if (#song.instruments<254) then
          sel_ins=#song.instruments+1
          song:insert_instrument_at(sel_ins)
          song:instrument(sel_ins):insert_sample_at(1)
          sel_sam=1
          song.selected_instrument_index=sel_ins
        else
          rnd_txt_piece_song()
          return rna:show_error(("%s:\nIt is not possible to add a new instrument to load the render.\nThe number must be less than "..
                                 "254 (< FE).\nIf necessary, use \"Selected Instrument\" Destination Slot."):format(rnd_main_title))
        end
      end
      if (vws.RND_RENAME_CHX_INS.value==true) then
        song:instrument(sel_ins).name=vws.RND_RENAME_TXF_INS.text
      end
      if (vws.RND_RENAME_CHX_SAM.value==true) then
        song:instrument(sel_ins):sample(sel_sam).name=vws.RND_RENAME_TXF_SAM.text
      end
      song:instrument(sel_ins):sample(sel_sam).sample_buffer:load_from(filename)
      if (vws.RND_SHOW_WAVEFORM.value==true) then
        rna.window.active_middle_frame=renoise.ApplicationWindow.MIDDLE_FRAME_INSTRUMENT_SAMPLE_EDITOR
      end
      os.remove(filename)
      rnd_txt_piece_song()
      rnd_main_dialog()
      
      --restart track mute state
      if (vws.RND_SW_PIECE_SONG.value==3) then --slots selection in matrix
        for trk=1,stc do --#song.tracks do
          if (song:track(trk).type==renoise.Track.TRACK_TYPE_SEQUENCER) then
            song:track(trk).mute_state=RNK_TRK_MUTE_STATE[trk]
          end
        end
      end

      --restart track mute state
      if (vws.RND_SW_PIECE_SONG.value==4) then --lines selection in pattern
        for trk=1,stc do --#song.tracks do
          if (song:track(trk).type==renoise.Track.TRACK_TYPE_SEQUENCER) then
            song:track(trk).mute_state=RNK_TRK_MUTE_STATE[trk]
          end
        end
      end
      
      --render direct
      if (RND_DIRECT==true) then
        RND_MAIN_DIALOG:close()
        RND_DIRECT=false
      end
      
      --jump to the next track
      if (vws.RND_JUMP_NEXT_TRACK.value) then
        if (song.selected_track_index<stc) then
          local next_tr=song.selected_track_index+1
          if (vws.RND_JUMP_NEXT_TR_OR_TRGR.value==1) then
            for tr=next_tr,stc do
              if (song:track(tr).type==renoise.Track.TRACK_TYPE_SEQUENCER) then
                song.selected_track_index=tr
                rnd_auto_sel_matrix(tr)
                --restore selected_instrument_index
                song.selected_instrument_index=sel_ins
                break
              end
            end
          else
            if (song.selected_track_index<stc) then
              song.selected_track_index=next_tr
              rnd_auto_sel_matrix(next_tr)
              --restore selected_instrument_index
              song.selected_instrument_index=sel_ins
            end
          end
        end
      end
      local time=(os.clock()-clk)--*1000
      rna:show_status(("%s:  Rendering duration: %.2f seconds"):format(rnd_main_title,time))
    end
    ---
    --render the song
    song:render(settings,filename,rendering_done_callback)
  else
    rnd_txt_piece_song()
    song:cancel_rendering()
    RND_DONE_CANCEL=false
  end
end



--update sequence values
local function rnd_update_seq_range_1()
  vws.RND_RW_SEQ_RANGE_1.max=vws.RND_RW_SEQ_RANGE_2.value
end
---
local function rnd_update_seq_range_2(value)
  if (#song.sequencer.pattern_sequence-1>0) then
    vws.RND_RW_SEQ_RANGE_2.max=#song.sequencer.pattern_sequence-1
  else
    vws.RND_RW_SEQ_RANGE_2.max=1
  end
  vws.RND_RW_SEQ_RANGE_1.max=vws.RND_RW_SEQ_RANGE_2.value
  if (vws.RND_RW_SEQ_RANGE_1.value>=value) then
    vws.RND_RW_SEQ_RANGE_1.value=value
  end
end



--update lines values
local function rnd_update_lns_range_1()
  vws.RND_RW_LNS_RANGE_1.max=vws.RND_RW_LNS_RANGE_2.value-1
end

local function rnd_update_lns_range_2(value)
  if (song.selected_pattern.number_of_lines-1>0) then
    vws.RND_RW_LNS_RANGE_2.max=song.selected_pattern.number_of_lines-1
  else
    vws.RND_RW_LNS_RANGE_2.max=1
  end
  vws.RND_RW_LNS_RANGE_1.max=vws.RND_RW_LNS_RANGE_2.value
  if (value>0) then
    if (vws.RND_RW_LNS_RANGE_1.value>=value) then
      vws.RND_RW_LNS_RANGE_1.value=value-1
    end
  else
    vws.RND_RW_LNS_RANGE_1.value=0
  end
end



--active/deactive priority panels
local function rnd_options_priority(value)
  if (value==1) then
    vws.RND_OPT_INTERPOLATION.active=false
    vws.RND_OPT_SAMPLE_RATE.active=false
  else
    vws.RND_OPT_INTERPOLATION.active=true
    vws.RND_OPT_SAMPLE_RATE.active=true
  end
end



--show pattern editor or sampler/waveform
function rnd_bt_edit_wave()
  if (rna.window.active_middle_frame~=renoise.ApplicationWindow.MIDDLE_FRAME_PATTERN_EDITOR) then
    rna.window.active_middle_frame=renoise.ApplicationWindow.MIDDLE_FRAME_PATTERN_EDITOR
  elseif (rna.window.active_middle_frame~=renoise.ApplicationWindow.MIDDLE_FRAME_INSTRUMENT_SAMPLE_EDITOR) then
    rna.window.active_middle_frame=renoise.ApplicationWindow.MIDDLE_FRAME_INSTRUMENT_SAMPLE_EDITOR
  end
  rnd_main_dialog()
end


--autocapture
local function rnd_capture_name_tr()
  vws.RND_RENAME_TXF_SAM.text=song.selected_track.name
end

local function rnd_autocapture_track_name(value)
  --print(value)
  if (value) then
    if not song.selected_track_observable:has_notifier(rnd_capture_name_tr) then
      song.selected_track_observable:add_notifier(rnd_capture_name_tr)
    end
    if not song.selected_track.name_observable:has_notifier(rnd_capture_name_tr) then
      song.selected_track.name_observable:add_notifier(rnd_capture_name_tr)
    end
    rnd_capture_name_tr()
    print("true")
  else
    if song.selected_track_observable:has_notifier(rnd_capture_name_tr) then
      song.selected_track_observable:remove_notifier(rnd_capture_name_tr)
    end
    if song.selected_track.name_observable:has_notifier(rnd_capture_name_tr) then
      song.selected_track.name_observable:remove_notifier(rnd_capture_name_tr)
    end
    print("false")
  end
end




-------------------------------------------------------------------------------------------------
--main content gui

local function rnd_sw_piece_song(value)
  if (value==1) then
    vws.RND_SEQ_RANGE.visible=false
    vws.RND_MATRIX_SEL.visible=false
    vws.RND_LNS_RANGE.visible=false
    --vws.RND_RW_JUMP_NEXT_TRACK.visible=false
    vws.RND_JUMP_NEXT_TRACK.active=false
    vws.RND_JUMP_NEXT_TRACK.value=false
    vws.RND_JUMP_NEXT_TR_OR_TRGR.value=2
    vws.RND_BT_RENDER.text="Render Song"
  elseif (value==3) then
    vws.RND_SEQ_RANGE.visible=false
    vws.RND_LNS_RANGE.visible=false
    vws.RND_MATRIX_SEL.visible=true
    --vws.RND_RW_JUMP_NEXT_TRACK.visible=true
    vws.RND_JUMP_NEXT_TRACK.active=true
    vws.RND_BT_RENDER.text="Render Matrix"
  elseif (value==2) then
    vws.RND_LNS_RANGE.visible=false
    vws.RND_MATRIX_SEL.visible=false
    vws.RND_SEQ_RANGE.visible=true
    --vws.RND_RW_JUMP_NEXT_TRACK.visible=false
    vws.RND_JUMP_NEXT_TRACK.active=false
    vws.RND_JUMP_NEXT_TRACK.value=false
    vws.RND_JUMP_NEXT_TR_OR_TRGR.value=2
    vws.RND_BT_RENDER.text="Render Seq."
  else
    vws.RND_SEQ_RANGE.visible=false
    vws.RND_MATRIX_SEL.visible=false
    vws.RND_LNS_RANGE.visible=true
    --vws.RND_RW_JUMP_NEXT_TRACK.visible=false
    vws.RND_JUMP_NEXT_TRACK.active=false
    vws.RND_JUMP_NEXT_TRACK.value=false
    vws.RND_JUMP_NEXT_TR_OR_TRGR.value=2
    vws.RND_BT_RENDER.text="Render Pattern"
  end
end

local function rnd_top_bar()
  local piece_song=vb:column{
    vb:space{height=1},
    vb:row{
      vb:switch{
        id="RND_SW_PIECE_SONG",
        height=RND_VB_HEIGHT_2,
        width=363,
        value=1,
        items={"Entire Song","Seq. Range","Matrix Sel.","Pattern Sel."},
        notifier=function(value) rnd_sw_piece_song(value) end,
        tooltip="Render Selector\n"..
                  "  Entire Song: renders the entire song & load it into a sample.\n"..
                  "  Seq Range: renders a specific sequence range & load it into a sample.\n"..
                  "  Matrix Sel.: renders the selection inside the matrix editor & load it into a sample.\n"..
                  "  Pattern Sel.: renders a lines range of the selected pattern & load it into a sample."
      },
      vb:button{
        height=RND_VB_HEIGHT_2,
        width=27,
        bitmap="ico/question_ico.png",
        notifier=function() if (vws.RND_HELP.visible) then vws.RND_HELP.visible=false vws.RND_CONFIG_PANEL.visible=true vws.RND_SW_PIECE_SONG.active=true else vws.RND_CONFIG_PANEL.visible=false vws.RND_HELP.visible=true vws.RND_SW_PIECE_SONG.active=false end end,
        tooltip="Information about "..rnd_main_title.." tool & basic key commands."
      }
    },
    vb:space{height=1}
  }
  return piece_song
end
---
local function rnd_seq_range()
  local seq_range=vb:row{
    id="RND_SEQ_RANGE",
    visible=false,
    vb:row{
      vb:text{
        height=RND_VB_HEIGHT,
        width=98,
        align="right",
        text="Seq. Range"
      },
      vb:row{
        spacing=-2,
        vb:valuebox{
          id="RND_RW_SEQ_RANGE_1",
          active=false,
          height=RND_VB_HEIGHT,
          width=63,
          min=0,
          max=9999,
          value=0,
          tostring=function(value) return ("%.1d"):format(value) end,
          tonumber=function(value) return tonumber(value) end,
          notifier=function() rnd_update_seq_range_1() end
        },
        vb:valuebox{
          id="RND_RW_SEQ_RANGE_2",
          active=false,
          height=RND_VB_HEIGHT,
          width=63,
          min=0,
          max=9999,
          value=0,
          tostring=function(value) return ("%.1d"):format(value) end,
          tonumber=function(value) return tonumber(value) end,
          notifier=function(value) rnd_update_seq_range_2(value) end
        }
      },
      vb:space{width=16},
      vb:checkbox{
        id="RND_CHK_SEQ_RNG_AUTO_ADJUST",
        height=RND_VB_HEIGHT,
        width=RND_VB_HEIGHT,
        value=true,
        notifier=function(value)
          if (value) then
            vws.RND_RW_SEQ_RANGE_1.active=false
            vws.RND_RW_SEQ_RANGE_2.active=false
          else
            vws.RND_RW_SEQ_RANGE_1.active=true
            vws.RND_RW_SEQ_RANGE_2.active=true
          end
        end
      },
      vb:text{
        height=RND_VB_HEIGHT,
        width=124,
        text="Auto-adjust"
      }
    }
  }
  return seq_range
end
---
local function rnd_matrix_sel()
  local matrix_sel=vb:row{
    id="RND_MATRIX_SEL",
    visible=false,
    vb:column{
      vb:text{
        height=RND_VB_HEIGHT,
        width=336,
        text="Select before one or more slots in matrix editor to render!"
      }
    }
  }
  return matrix_sel
end
---
local function rnd_lns_range()
  local lns_range=vb:row{
    id="RND_LNS_RANGE",
    visible=false,
    vb:row{
      vb:text{
        height=RND_VB_HEIGHT,
        width=98,
        align="right",
        text="Pattern Sel."
      },
      vb:row{
        spacing=-2,
        vb:valuebox{
          id="RND_RW_LNS_RANGE_1",
          active=false,
          height=RND_VB_HEIGHT,
          width=63,
          min=0,
          max=64,
          value=0,
          tostring=function(value) return ("%.2d"):format(value) end,
          tonumber=function(value) return tonumber(value) end,
          notifier=function() rnd_update_lns_range_1() end
        },
        vb:valuebox{
          id="RND_RW_LNS_RANGE_2",
          active=false,
          height=RND_VB_HEIGHT,
          width=63,
          min=0,
          max=64,
          value=1,
          tostring=function(value) return ("%.2d"):format(value) end,
          tonumber=function(value) return tonumber(value) end,
          notifier=function(value) rnd_update_lns_range_2(value) end
        }
      },
      vb:space{width=16},
      vb:checkbox{
        id="RND_CHK_LNS_RNG_AUTO_ADJUST",
        height=RND_VB_HEIGHT,
        width=RND_VB_HEIGHT,
        value=true,
        notifier=function(value)
          if (value) then
            vws.RND_RW_LNS_RANGE_1.active=false
            vws.RND_RW_LNS_RANGE_2.active=false
          else
            vws.RND_RW_LNS_RANGE_1.active=true
            vws.RND_RW_LNS_RANGE_2.active=true
          end
        end
      },
      vb:text{
        height=RND_VB_HEIGHT,
        width=124,
        text="Auto-adjust"
      }
    }
  }
  return lns_range
end
---
local function rnd_configuration()
  local destination=vb:row{
    margin=1,
    vb:column{
      style="group",
      margin=4,
      vb:text{
        height=RND_VB_HEIGHT,
        width=381,
        align="center",
        font="bold",
        style="strong",
        text="Configuration"
      },
      rnd_seq_range(),
      rnd_lns_range(),
      vb:row{
        vb:text{
          height=RND_VB_HEIGHT,
          width=98,
          align="right",
          text="Rename"
        },
        vb:row{
          margin=1,
          vb:column{
            style="panel",
            margin=3,
            vb:row{
              vb:checkbox{
                id="RND_RENAME_CHX_INS",
                height=RND_VB_HEIGHT,
                width=RND_VB_HEIGHT,
                value=true,
                notifier=function(value)
                  if (value) then
                    vws.RND_RENAME_TXF_INS.active=true
                  else
                    vws.RND_RENAME_TXF_INS.active=false
                  end
                  vws.RND_RENAME_TXF_INS.edit_mode=value
                end
              },
              vb:text{
                height=RND_VB_HEIGHT,
                width=78,
                text="Instrument"
              },
              vb:textfield{
                id="RND_RENAME_TXF_INS",
                height=RND_VB_HEIGHT,
                width=178,
                text="Instrument Wave"
              }
            },
            vb:row{
              vb:checkbox{
                id="RND_RENAME_CHX_SAM",
                height=RND_VB_HEIGHT,
                width=RND_VB_HEIGHT,
                value=false,
                notifier=function(value)
                  if (value) then
                    vws.RND_CB_AUTOCAP_NAME_TR.active=true
                    vws.RND_RENAME_TXF_SAM.active=true
                  else
                    vws.RND_CB_AUTOCAP_NAME_TR.active=false
                    vws.RND_CB_AUTOCAP_NAME_TR.value=false
                    vws.RND_RENAME_TXF_SAM.active=false
                  end
                  vws.RND_RENAME_TXF_SAM.edit_mode=value
                end
              },
              vb:text{
                height=RND_VB_HEIGHT,
                width=78,
                text="Sample"
              },
              vb:textfield{
                id="RND_RENAME_TXF_SAM",
                active=false,
                height=RND_VB_HEIGHT,
                width=178,
                text="Sample Wave"
              }
            },
            vb:row{
              id="RND_RW_AUTOCAP_NAME_TR",
              vb:checkbox{
                id="RND_CB_AUTOCAP_NAME_TR",
                active=false,
                height=RND_VB_HEIGHT,
                width=RND_VB_HEIGHT,
                value=false,
                notifier=function(value) rnd_autocapture_track_name(value) end
              },
              vb:text{
                height=RND_VB_HEIGHT,
                width=256,
                text="Auto-capture track name for sample"
              }
            }
          }
        }
      },
      vb:row{
        vb:text{
          height=RND_VB_HEIGHT,
          width=98,
          align="right",
          text="After Process"
        },
        vb:row{
          margin=1,
          vb:column{
            style="panel",
            margin=3,
            vb:row{
              vb:checkbox{
                id="RND_SHOW_WAVEFORM",
                height=RND_VB_HEIGHT,
                width=RND_VB_HEIGHT,
                value=true
              },
              vb:text{
                height=RND_VB_HEIGHT,
                width=255,
                text="Show modified sample in Waveform"
              }
            },
            vb:row{
              vb:checkbox{
                id="RND_JUMP_NEXT_TRACK",
                height=RND_VB_HEIGHT,
                width=RND_VB_HEIGHT,
                value=false,
                notifier=function(value) vws.RND_JUMP_NEXT_TR_OR_TRGR.active=value end,
                tooltip="This option is very useful to render entire tracks or pieces of them or "..
                        "entire groups to load in individual samples very quickly (only for Matrix Sel.)."
              },
              vb:text{
                height=RND_VB_HEIGHT,
                width=164,
                text ="Select next track after"
              },
              vb:column{
                vb:space{height=2},
                vb:switch{
                  id="RND_JUMP_NEXT_TR_OR_TRGR",
                  active=false,
                  height=RND_VB_HEIGHT,
                  width= 92,
                  value=2,
                  items= {"Tr","Tr/Gr"},
                  tooltip="Jump only to the next track (Tr) or to the next track or group(Tr/Gr).\n"..
                          "The range of selection in the sequence is maintained."
                }
              }
            }
          }
        }
      }
    }
  }
  return destination
end
---
local function rnd_options()
  local options=vb:row{
    margin=1,
    vb:column{
      style="group",
      margin=4,
      vb:text{
        height=RND_VB_HEIGHT,
        width=381,
        align="center",
        font="bold",
        style="strong",
        text="Render Options"
      },
      vb:row{
        vb:text{
          height=RND_VB_HEIGHT,
          width=98,
          align="right",
          text="Priority"
        },
        vb:popup {
          id="RND_OPT_PRIORITY",
          height=RND_VB_HEIGHT,
          width=283,
          value=3,
          items={" Real-Time"," Low (render in background)"," High (as fast as possible)"},
          notifier=function(value) rnd_options_priority(value) end
        }
      },
      vb:row{
        vb:text{
          height=RND_VB_HEIGHT,
          width=98,
          align="right",
          text="Interpolation"
        },
        vb:popup {
          id="RND_OPT_INTERPOLATION",
          height=RND_VB_HEIGHT,
          width=283,
          value=2,
          items={" Default (as played)"," Precise (HQ, but slow)"},
        }
      },
      vb:row{
        vb:text{
          height=RND_VB_HEIGHT,
          width=98,
          align="right",
          text="Sample Rate"
        },
        vb:popup {
          id="RND_OPT_SAMPLE_RATE",
          height=RND_VB_HEIGHT,
          width=283,
          value=3,
          items={" 22.050 Hz"," 44.100 Hz"," 48.000 Hz"," 88.200 Hz"," 96.000 Hz"," 192.000 Hz"},
        }
      },
      vb:row{
        vb:text{
          height=RND_VB_HEIGHT,
          width=98,
          align="right",
          text="Bit depth"
        },
        vb:popup {
          id="RND_OPT_BIT_DEPTH",
          height=RND_VB_HEIGHT,
          width=283,
          value=2,
          items={" 16 Bit"," 24 Bit"," 32 Bit"},
        }
      },
      vb:row{
        vb:text{
          height=RND_VB_HEIGHT,
          width=98,
          align="right",
          text="Destiny"
        },
        vb:switch{
          id="RND_SW_DESTINATION",
          height=RND_VB_HEIGHT,
          width=283,
          value=1,
          items={"Overwrite","Accumulate","New Instr."},
          tooltip="- Overwrite: destroy each sample and render a new one. Be aware of what you are doing!\n"..
                  "- Accumulate: will save the sample to a new accumulated sample at the bottom of the sample list for the selected instrument.\n"..
                  "- New Instrument: make a new copy of the instrument and work on it."
        }
      }
    }
  }
  return options
end
---
local function rnd_bt_render()
  local bt_render=vb:button{
    id="RND_BT_RENDER",
    height=RND_VB_HEIGHT_2,
    width=128,
    text="Render Song",
    notifier=function() rnd_render_song() end,
    tooltip="Start/stop the render\n[R.CTRL]"
  }
  return bt_render
end
---
local function rnd_progress()
  local progress=vb:vertical_aligner{
    height=RND_VB_HEIGHT_2,
    mode="center",
    vb:row{
      margin=1,
      spacing=-229,
      vb:row{
        style="plain",
        margin=-1,
        vb:text{
          id="RND_TXT_PATH_FOLDER",
          height=19,
          width=231,
          align="center",
          text=""
        }
      },
      vb:column{
        id="RND_BMP_PROCESS",
        visible=false,
        width=1,
        vb:bitmap{
          bitmap="ico/process_ico.png"
        }
      }
    }
  }
  return progress
end
---
local function rnd_edit_wave()
  local edit_wave=vb:button{
    height=RND_VB_HEIGHT_2,
    width=31,
    bitmap="/ico/panel_ico.png",
    notifier=function() rnd_bt_edit_wave() end,
    tooltip="Show Pattern Editor or Sampler/Waveform\n[APPS]"
  }
  return edit_wave
end
---
local function rnd_help()
  local help=vb:column{
    id="RND_HELP",
    visible=false,
    margin=1,
    vb:column{
      id="RND_PNL_TXT",
      spacing=-3,
      margin=4,
      style="plain",
      vb:text{
        width=381,
        align="center",
        font="bold",
        style="strong",
        text=RND_COM_TITLE[1]
      },
      vb:text{
        width=381,
        text=RND_ABOUT_TFD
      },
      vb:space{height=11},
      vb:text{
        width=381,
        align="center",
        font="bold",
        style="strong",
        text=RND_COM_TITLE[2]
      }
    }
  }
  for i=1,10,2 do
    vws.RND_PNL_TXT:add_child(vb:row{
        vb:text{width=185,text=RND_COM_TXT[i]}, vb:text{width=185,text=RND_COM_TXT[i+1]}
      }
    )
  end
  vws.RND_PNL_TXT:add_child(
    vb:text{
      width=381,
      text=RND_COM_TXT[11]
    }
  )
  return help
end

local function rnd_config_panel()
  local config=vb:column{
    id="RND_CONFIG_PANEL",
    visible=true,
    spacing=2,
    rnd_matrix_sel(),
    rnd_configuration(),
    rnd_options(),
    vb:row{
      rnd_bt_render(),
      rnd_progress(),
      rnd_edit_wave()
    }
  }
  return config
end

--main gui
local function rnd_main_content()
  RND_MAIN_CONTENT=vb:column{
    margin=3,
    spacing=2,
    rnd_top_bar(),
    rnd_config_panel(),
    rnd_help(),
    --vb:button {text="T", notifier=function() rnd_test() end }
  }
  return RND_MAIN_CONTENT
end



--restart options
local function rnd_restart_opt()
  RND_TRK={1,1}
  RND_SEQ={1,1}
  ---
  vws.RND_SW_PIECE_SONG.value=1                 --entire song --> select next track=false & Tr/Gr
  vws.RND_SW_DESTINATION.value=3 --1                --next instrument
  --vws.RND_INSERT_SAMPLE.value=true              --insert a new sample
  vws.RND_SHOW_WAVEFORM.value=true              --show modified sample
  ---
  vws.RND_RENAME_CHX_INS.value=true             --instrument rename
  vws.RND_RENAME_TXF_INS.text="Instrument Wave" --text instrument rename
  vws.RND_RENAME_CHX_SAM.value=false            --sample rename --> autocapture track name=false
  vws.RND_RENAME_TXF_SAM.text="Sample Wave"     --texn sample rename
  ---
  vws.RND_RW_SEQ_RANGE_1.value=0                --sequence range 1
  vws.RND_RW_SEQ_RANGE_2.value=0                --sequence range 2
  vws.RND_RW_LNS_RANGE_1.value=0                --line range 1
  vws.RND_RW_LNS_RANGE_2.value=1                --line range 2
  ---
  vws.RND_OPT_PRIORITY.value=3                  --priority
  vws.RND_OPT_INTERPOLATION.value=2             --interpolation
  vws.RND_OPT_SAMPLE_RATE.value=3               --sample rate
  vws.RND_OPT_BIT_DEPTH.value=3                 --bit depth
end



-------------------------------------------------------------------------------------------------
--show main_dialog
function rnd_main_dialog()
  --first invoke status
  if (RND_INVOKE_STATUS==true) then
    rna:show_status(("%s:  Preloading the window..."):format(rnd_main_title))
    RND_INVOKE_STATUS=false
  end

  --main content gui
  if (RND_MAIN_CONTENT==nil) then
    rnd_main_content()
  end
  
  --require
  require ("lua/keyhandler")

  --avoid showing the same window several times!
  if (RND_MAIN_DIALOG) and (RND_MAIN_DIALOG.visible) then RND_MAIN_DIALOG:show() return end

  --last invoke status
  rna:show_status( ("%s:  Window sucesfully loaded."):format(rnd_main_title))
  
  --custom dialog
  RND_MAIN_DIALOG=rna:show_custom_dialog(" "..rnd_main_title,RND_MAIN_CONTENT,rnd_keyhandler)
  
  --restart options
  if not renoise.tool().app_new_document_observable:has_notifier(rnd_restart_opt) then
    renoise.tool().app_new_document_observable:add_notifier(rnd_restart_opt)
  end  
end
_AUTO_RELOAD_DEBUG=function() rnd_main_dialog() end


-------------------------------------------------------------------------------------------------
--register menu entry
rnt:add_menu_entry{
  name="Main Menu:File:Render with "..rnd_main_title.." (Entire Song)...",
  invoke=function() rnd_main_dialog() vws.RND_SW_PIECE_SONG.value=1 end
}
rnt:add_menu_entry{
  name="Main Menu:Tools:"..rnd_main_title.."...",
  invoke=function() rnd_main_dialog() end
}

rnt:add_menu_entry{
  name="Sample Navigator:"..rnd_main_title.."...",
  invoke=function() rnd_main_dialog() end
}

rnt:add_menu_entry{
  name="Pattern Matrix:"..rnd_main_title.." (Seq. Range)...",
  invoke=function() rnd_main_dialog() vws.RND_SW_PIECE_SONG.value=2 end
}

rnt:add_menu_entry{
  name="Pattern Matrix:"..rnd_main_title.." (Matrix Sel.)...",
  invoke=function() rnd_main_dialog() vws.RND_SW_PIECE_SONG.value=3 end
}

rnt:add_menu_entry{
  name="Pattern Editor:"..rnd_main_title.." (Pattern Sel.)...",
  invoke=function() rnd_main_dialog() vws.RND_SW_PIECE_SONG.value=4 end
}

--invoke main dialog
rnt:add_keybinding {
  name="Global:Tools:"..rnd_main_title,
  invoke=function() rnd_main_dialog() end
}


--direct rendering
local function rnd_direct()
  rnd_main_dialog()
  RND_DIRECT=true
  rnd_render_song()
end
---
local function rnd_select_all_gr()
  local sti=song.selected_track_index
  local ssq=song.sequencer
  local function select(sti,ssq)
    for trk=sti-#song:track(sti).members,sti do
      for seq=1,#ssq.pattern_sequence do
        ssq:set_track_sequence_slot_is_selected(trk,seq,true)
      end
    end
  end
  if (song:track(sti).type==renoise.Track.TRACK_TYPE_GROUP) then
    --print("gr")
    select(sti,ssq)
  elseif (song:track(sti).type==renoise.Track.TRACK_TYPE_SEQUENCER) then
    if (song:track(sti).group_parent~=nil) then
      oprint(song:track(sti).group_parent)
      for trk=sti,#song.tracks do
        if (song:track(trk).type==renoise.Track.TRACK_TYPE_GROUP) then
          sti=trk
          break
        end
      end
      song.selected_track_index=sti
      select(sti,ssq)
    else
      return rna:show_error(("%s:\nThe selected track is not a \"group\"!"):format(rnd_main_title))
    end
  end
end
---
rnt:add_menu_entry{
  name=("Main Menu:Tools:%s (Direct Rendering)"):format(rnd_main_title),
  invoke=function() rnd_direct() end
}
---
rnt:add_menu_entry{
  name=("Pattern Matrix:%s (Direct Rendering)"):format(rnd_main_title),
  invoke=function() rnd_direct() end
}
rnt:add_menu_entry{
  name=("Pattern Matrix:Track:Select All Group (%s)"):format(rnd_main_title),
  invoke=function() rnd_select_all_gr() end
}
---
rnt:add_keybinding {
  name=("Global:Tools:%s (Direct Rendering)"):format(rnd_main_title),
  invoke=function() rnd_direct() end
}


--**************************************
--collectgarbage (bottom)
  --print( "collectgarbage:", collectgarbage("count"), "KBytes (SamRender)" )
  --collectgarbage( "restart" )
--**************************************
